<template>
  <!-- @todo: Remove eslint-disable -->
  <!-- eslint-disable vue/no-mutating-props -->
  <div
    class="dropdown is-up"
    :class="{ 'is-active': open }"
  >
    <div class="dropdown-trigger">
      <button
        class="button"
        type="button"
        aria-haspopup="true"
        aria-controls="dropdown-menu"
        @click="open = !open"
      >
        <span><slot /></span>
        <span class="icon is-small">
          <fa-icon :icon="['fas', 'angle-down']" />
        </span>
      </button>
    </div>
    <div
      class="dropdown-menu"
      role="menu"
    >
      <div class="dropdown-content">
        <button
          v-for="(option, id) in options"
          :key="id"
          type="button"
          class="dropdown-item"
          @click="propagate(id)"
        >
          {{ option }}
        </button>
      </div>
    </div>
  </div>
</template>
<script>
export default {
  props: {
    options: {
      type: Object,
      default: () => ({}),
    },
    open: {
      type: Boolean,
      default: false,
    },
  },
  methods: {
    propagate(id) {
      this.$emit('click', id);
    },
  },
};
</script>
<style scoped lang="scss">
  @import "~assets/css/head";
  @import "~bulma/sass/components/dropdown.sass";
  .dropdown {
    &.is-danger {
      .button {
        background: $danger;
        color: $text-invert;
        border: none;
      }
      .dropdown-item {
        color: $danger;
        background: none;
        border: none;
        border-bottom: 1px solid $danger;
        cursor: pointer;
        padding: 10px;
      }
      .dropdown-menu {
      padding-bottom: 0;
      }
      .dropdown-content {
        border: 1px solid $danger;
        border-bottom: none;
        padding: 0;
      }
    }
  }
</style>
